import { Action, StateValue, IStateNodeConfig } from "./types";
import matchesState from "./matchesState";
import mapState from "./mapState";
import State from "./State";
declare class StateNode {
    key: string;
    id: string;
    initial?: string;
    parallel?: boolean;
    states: Record<string, StateNode>;
    on?: Record<string, string>;
    parent?: StateNode;
    private _events?;
    private _relativeValue;
    private _initialState;
    constructor(config: IStateNodeConfig);
    transition(state: StateValue | State, action: Action): State | undefined;
    transitionStateValue(state: StateValue | State, action: Action): StateValue | undefined;
    next(action: Action, history?: StateValue): StateValue | undefined;
    getInitialState(): StateValue | undefined;
    readonly initialState: StateValue | undefined;
    getState(relativeStateId: string): StateNode | undefined;
    readonly events: string[];
    getRelativeValue(toNode?: StateNode): StateValue;
}
declare function Machine(config: IStateNodeConfig): StateNode;
export { StateNode, Machine, State, matchesState, mapState };
